/****************************************************************************/
/*  Copyright 2005, Trustees of Indiana University                          */
/*  Author: Sidharth Thakur                                                 */
/*  Last modified: 14 January 2006                                          */
/*  License available at: <belt-trick-* folder>/docs/downloads/License.txt  */
/****************************************************************************/
#ifndef _OGLWIDGETFLOATING_
#define _OGLWIDGETFLOATING_

#include <qgl.h>
#include "all.h"

class OGLWidgetFloating : public QGLWidget 
{
public:
	OGLWidgetFloating( QWidget* parent, const char* name, QWidget* parentForm );
	~OGLWidgetFloating ( );

public: //VARIABLES
	// world center
	GLfloat			XC, YC, ZC;					//
    int				X,	Y,	dX, dY;				//
    GLfloat			Cx, Cy, Cz;					//
    double			m_viewScale;				//
    int				main_height, main_width;	//
    int     		enable_picking;				//
    float			xCoord[MAX_POINTS];			//
    float			yCoord[MAX_POINTS];			//
    float			zCoord[MAX_POINTS];			//

	// lighting
    GLfloat 		global_light0[4];			//

	// View-port parameters
    float			xMin;						//
    float			xMax;						//
    float			yMin;						//
    float			yMax;						//
    float			zNear;						//
    float			zFar;						//

	// mouse event data handlers
    float			startY;						//
    int				xBegin, xNext;				//
    int				yBegin, yNext;				//
	int				modkey;						//
    int				button;						//
    int				mouseModifiers;				//
	int				mouseButtons;				//

	// mouse: picking data handlers
	int				litVertex;					//
    int				movingPoint;				//


public: //FUNCTIONS
	/* ADMINISTRATION */
	//window operations
	void			initializeGL		( void );						//
	void			init				( void );						//
	void			setupLights			( void );						//
	void			paintGL				( void );						//
	void			resizeGL			( int wd, int ht ); 			//
	void			resetApp			( void );						//
    void            renderAxes          ( void );
	void			showOnScreenText	( void );
	void			text				( char* string );

	//event handlers
    //   void			keyPressEvent				( QKeyEvent *e );		//			
	void			mousePressEvent				( QMouseEvent *e );		//
	void			mouseReleaseEvent			( QMouseEvent *e );		//
	void			moveTransformedCoordinate	( float x, float y );	//
	void			mouseMoveEvent				( QMouseEvent *e );		//
    void            keyPressEvent               ( QKeyEvent *e );
        

    /* local declrations */
    int             fwin_showAxes;
        
};


#endif

