/****************************************************************************/
/*  Copyright 2005, Trustees of Indiana University                          */
/*  Author: Sidharth Thakur                                                 */
/*  Last modified: 14 January 2006                                          */
/*  License available at: <belt-trick-* folder>/docs/downloads/License.txt  */
/****************************************************************************/
#ifndef _VISIBLEFORM_
#define _VISIBLEFORM_

#include "MainForm.h"
#include "MathObject.h"
#include "OGLWidgetMain.h"
#include "OGLWidgetFloating.h"
#include "structs.h"
#include "InstructionBrowser.h"
#include "forms/InstructionScreen.h"

//qt includes
#include <qapplication.h>
#include <qcheckbox.h>
#include <qcombobox.h>
#include <qgroupbox.h>
#include <qlabel.h>
#include <qmessagebox.h>
#include <qpushbutton.h>
#include <qradiobutton.h>
#include <qslider.h>
#include <qstring.h>
#include <qtabwidget.h>
#include <qtimer.h>
#include <qtextedit.h>
#include <qtextview.h>

class VisibleForm : public MainForm 
{
public:
	VisibleForm ( QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
	~VisibleForm();

private:
	OGLWidgetMain		*vp;		// Viewing Pane
	OGLWidgetFloating	*fwin_vp;   // Floating Window Viewing Pane
	InstructionScreen	*fwin_inst;
	
	HelpWindow			*help;

public:
	MathObject		*mo;		    // Math Object

protected:
	void			timerEvent			( QTimerEvent* );
	QTextView		*textView;
public:
	int				swapFrames;	    
	void			notifyOGLWidgets	( void );
	void			calbak_Help			( void );

protected:
	void			initForm			( void );
	void			resizeEvent			( QResizeEvent* );		
	void			closeEvent			( QCloseEvent* );
	void			genHelpString		( void );
	QString			helpstr;

public:
	void			exitApp				( void );

	virtual void calbak_TimerEvent		( void );

public:
	//----------------------------------------------//
	/* ADMINISTRATION */
	//----------------------------------------------//

	virtual void calbak_ResetApp			( void );
	virtual void calbak_ViewControl_Frames	( void );
    virtual void calbak_ViewControl_Faces();
    virtual void calbak_ViewControl_Axes();
    virtual void calbak_ViewControl_EdgesOnly();
	virtual void calbak_ViewControl_BeltNumbers ( );
	virtual void calbak_ViewControl_BeltTracker();
        
	//----------------------------------------------//
	/* BELT */
	//----------------------------------------------//

	virtual void calbak_Belt_Setup			( void );
    virtual void calbak_Belt_BoundingSpheres( void );
    virtual void calbak_BeltTransform_Angle	( void );
    virtual void calbak_BeltTransform_Type	( void );
    virtual void calbak_BeltTransform_Width ( );
    virtual void calbak_Belt_BSpheresMode	( void );
    virtual void calbak_Swap_Frames			( void );
    virtual void calbak_Belt_BSpheresNumber	( );	
    virtual void calbak_BeltTransform_Multiple( void );
    virtual void calbak_Belt_QuatComp       ( void );

    virtual void calbak_DumpScreen			( void );
    virtual void calbak_BeltTransform_SetupAngle ( void );
    virtual void calbak_Belt_TrackBelt		( );
	virtual void calbak_Belt_Reset			( );
	virtual void calbak_Belt_HideRest		( );
	virtual void calbak_Belt_ColorMode		( );
	virtual void calbak_Belt_Spine			( );
	virtual void timerDone ();
};

#endif
