/****************************************************************************/
/*  Copyright 2005, Trustees of Indiana University                          */
/*  Author: Sidharth Thakur                                                 */
/*  Last modified: 14 January 2006                                          */
/*  License available at: <belt-trick-* folder>/docs/downloads/License.txt  */
/****************************************************************************/
#ifndef _MATH3D_H_
#define _MATH3D_H_

double length3D(const double *pt1);

void minus3D(const double *vect1, const double *vect2, double *vect3);

double dot3D(const double *vect1, const double *vect2);

void cross3D(const double *v, const double *w, double *r);

void multMatVec(const double *v, const double *m, double *r);

void initVec(double *v);

void copyVec(const double *v1, double *v2);

void multScalarVec(const double d, const double *v, double *r);

int unify3D(double *vect);

void copy3D(double *vect1, const double *vect2);

void rotate3D_3(double *inOutVec, const double *axis, const double angle);

#endif
